Index: src/fortranscanner.l
===================================================================
--- src/fortranscanner.l	(revision 616)
+++ src/fortranscanner.l	(working copy)
@@ -325,7 +325,7 @@
 					  yy_push_state(InterfaceBody);
  					  startScope(last_entry);
                                         }
-<InterfaceBody>^{BS}"end"({BS_}"interface")?   {
+<InterfaceBody>^{BS}"end"({BS}"interface"({BS_}{ID})?)?{BS}/(\n|!)   {
 					  if (!endScope(current_root))
 					    yyterminate();
 					  yy_pop_state();
@@ -349,7 +349,7 @@
 					    BEGIN(Module);
                                             defaultProtection = Public;
                                        }
-<Start,ModuleBody>^{BS}"end"({BS_}(module|program))?{BS} { // end module	
+<Start,ModuleBody>^{BS}"end"({BS}(module|program)({BS_}{ID})?)?{BS}/(\n|!) { // end module	
 					    resolveModuleProcedures(moduleProcedures, current_root);
 					    if (!endScope(current_root))
 					      yyterminate();
@@ -406,7 +406,7 @@
 					    startScope(last_entry); 
                                             BEGIN(TypedefBody);
                                         }
-<TypedefBody>"end"{BS_}"type".*         { /* end type definition */
+<TypedefBody>^{BS}"end"{BS}"type"({BS_}{ID})?{BS}/(\n|!)         { /* end type definition */
                                            //cout << "=========> got typedef end "<< endl; 
 					   if (!endScope(current_root))
 					     yyterminate();
@@ -415,7 +415,7 @@
 
  /*------- module/global/typedef variable ---------------------------------------------------*/
 
-<SubprogBody>^{BS}"end"({BS_}{SUBPROG})?{BS} {  
+<SubprogBody>^{BS}"end"({BS}{SUBPROG}({BS_}{ID})?)?{BS}/(\n|!) {  
                                            //cout << "1e=========> got end subprog: " << yytext << endl;
 
                                            /* args is used for parameters in list of functions, argList for 
@@ -600,7 +600,7 @@
  				       } 
 <Parameterlist>{NOARGS}                {   
                                            yyLineNr++;
-					   //cout << "3=========> without parameterlist " <<endl;
+					   //printf("3=========> without parameterlist \n");
  					   stringToArgumentList("", current->argList);
                                            addCurrentEntry();
 					   startScope(last_entry);
@@ -1099,7 +1099,7 @@
 */
 static void addCurrentEntry()
 {
-  //cout << "Adding entry " <<current->name.data() << endl;
+  //printf("===Adding entry %s\n", current->name.data());
   current_root->addSubEntry(current);
   last_entry = current;
   current = new Entry ;
